
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runners.Parameterized;


/*
Classe de test pour le déplacement du cavalierB.
 */
public class TestDepD {
    @Parameterized.Parameter
    protected Dame dameB;
    @Parameterized.Parameter
    protected Dame dameN;
    @Parameterized.Parameter
    protected Dame dameB2;
    @Parameterized.Parameter
    protected Echiquier ech;

    @Before
    public void setUP(){
        dameB = new Dame(Piece.BLANC);
        dameN = new Dame(Piece.NOIR);
        dameB2 = new Dame(Piece.BLANC);
        ech = new Echiquier();
    }

    @After
    public void tearDown(){
    }

    @Test
    public void TestPlacement() throws Exception{
        ech.placer(dameB, 0, 0);
        Assert.assertEquals(dameB,ech.getPiece(0,0));
    }

    @Test
    public void TestDeplacement() throws Exception{
        /*
        Deplacement Diagonal
         */
        ech.placer(dameB,3,3);
        ech.deplacer(3,3,4,4);
        Assert.assertEquals(dameB, ech.getPiece(4,4));
        /*
        Deplacement Vertical
         */
        ech.placer(dameN, 4,2);
        ech.deplacer(4,2,5,2);
        Assert.assertEquals(dameN,ech.getPiece(5,2));
        /*
        Deplacement Horizontal
         */
        ech.placer(dameB2,5,3);
        ech.deplacer(5,3,5,4);
        Assert.assertEquals(dameB2,ech.getPiece(5,4));

    }

    @Test
    public void TestPrise() throws Exception{
        ech.placer(dameB, 4,4);
        ech.placer(dameN, 5,4);
        ech.deplacer(4,4,5,4);
        Assert.assertEquals(dameB,ech.getPiece(5,4));
    }
}