
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runners.Parameterized;


/*
Classe de test pour le déplacement du roi.
 */
public class TestDepR {
    @Parameterized.Parameter
    protected Roi roiB;
    @Parameterized.Parameter
    protected Roi roiN;
    @Parameterized.Parameter
    protected Roi roiB2;
    @Parameterized.Parameter
    protected Echiquier ech;

    @Before
    public void setUP(){
        roiB = new Roi(Piece.BLANC);
        roiN = new Roi(Piece.NOIR);
        roiB2 = new Roi(Piece.BLANC);
        ech = new Echiquier();
    }

    @After
    public void tearDown(){
    }

    @Test
    public void TestPlacement() throws Exception{
        ech.placer(roiB,5,5);
        Assert.assertEquals(roiB, ech.getPiece(5,5));
    }

    @Test
    public void TestDeplacement() throws Exception{
        /*
        Deplacement Vertical
         */
        ech.placer(roiB,5,5);
        ech.deplacer(5,5,6,5);
        Assert.assertEquals(roiB, ech.getPiece(6,5));
        /*
        Deplacement Horizontal
         */
        ech.placer(roiN, 3,3);
        ech.deplacer(3,3,3,4);
        Assert.assertEquals(roiN, ech.getPiece(3,4));
        /*
        Deplacement Diagonal
         */
        ech.placer(roiB2,6,6);
        ech.deplacer(6,6,7,7);
        Assert.assertEquals(roiB2, ech.getPiece(7,7));
    }

    @Test
    public void TestPrise() throws Exception{
        ech.placer(roiB, 5,5);
        ech.placer(roiN,6,5);
        ech.deplacer(5,5,6,5);
        Assert.assertEquals(roiB, ech.getPiece(6,5));
    }
}